'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Markup;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Parser = require('./Parser');

var _Parser2 = _interopRequireDefault(_Parser);

var _Element = require('./components/Element');

var _Element2 = _interopRequireDefault(_Element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

function Markup(_ref) {
  var content = _ref.content,
      emptyContent = _ref.emptyContent,
      disableLineBreaks = _ref.disableLineBreaks,
      disableWhitelist = _ref.disableWhitelist,
      tagName = _ref.tagName,
      noHtml = _ref.noHtml,
      noHtmlExceptMatchers = _ref.noHtmlExceptMatchers;

  var markup = new _Parser2.default(content, {
    noHtml: noHtml,
    noHtmlExceptMatchers: noHtmlExceptMatchers,
    disableLineBreaks: disableLineBreaks,
    disableWhitelist: disableWhitelist
  }).parse();
  var className = noHtml || noHtmlExceptMatchers ? 'interweave--no-html' : '';

  return _react2.default.createElement(
    _Element2.default,
    { tagName: tagName, className: className },
    markup.length ? markup : emptyContent || null
  );
}

Markup.propTypes = {
  content: _propTypes2.default.string,
  disableLineBreaks: _propTypes2.default.bool,
  disableWhitelist: _propTypes2.default.bool,
  emptyContent: _propTypes2.default.node,
  noHtml: _propTypes2.default.bool,
  noHtmlExceptMatchers: _propTypes2.default.bool,
  tagName: _propTypes2.default.oneOf(['span', 'div', 'p'])
};

Markup.defaultProps = {
  content: '',
  disableLineBreaks: false,
  disableWhitelist: false,
  emptyContent: null,
  noHtml: false,
  noHtmlExceptMatchers: false,
  tagName: 'span'
};