'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = Element;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

function Element(_ref) {
  var _ref$attributes = _ref.attributes,
      attributes = _ref$attributes === undefined ? {} : _ref$attributes,
      children = _ref.children,
      className = _ref.className,
      selfClose = _ref.selfClose,
      Tag = _ref.tagName;

  var props = (0, _extends3.default)({}, attributes);

  if (!selfClose || selfClose && Tag === 'img') {
    props.className = ['interweave', className || '', attributes.className || ''].filter(Boolean).join(' ');
  }

  if (selfClose) {
    return _react2.default.createElement(Tag, props);
  }

  return _react2.default.createElement(
    Tag,
    props,
    children || null
  );
}

Element.propTypes = {
  attributes: _propTypes2.default.objectOf(_propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool])),
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  selfClose: _propTypes2.default.bool,
  tagName: _propTypes2.default.string.isRequired
};

Element.defaultProps = {
  attributes: {},
  className: '',
  children: null,
  selfClose: false
};