'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = Hashtag;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Hashtag(_ref) {
  var children = _ref.children,
      encodeHashtag = _ref.encodeHashtag,
      hashtagUrl = _ref.hashtagUrl,
      preserveHash = _ref.preserveHash,
      props = (0, _objectWithoutProperties3.default)(_ref, ['children', 'encodeHashtag', 'hashtagUrl', 'preserveHash']);

  var hashtag = children;

  if (!preserveHash && hashtag.charAt(0) === '#') {
    hashtag = hashtag.substr(1);
  }

  if (encodeHashtag) {
    hashtag = encodeURIComponent(hashtag);
  }

  var url = hashtagUrl || '{{hashtag}}';

  if (typeof url === 'function') {
    url = url(hashtag);
  } else {
    url = url.replace('{{hashtag}}', hashtag);
  }

  return _react2.default.createElement(
    _Link2.default,
    (0, _extends3.default)({}, props, { href: url }),
    children
  );
} /**
   * @copyright   2016, Miles Johnson
   * @license     https://opensource.org/licenses/MIT
   * 
   */

Hashtag.propTypes = {
  children: _propTypes2.default.string.isRequired,
  encodeHashtag: _propTypes2.default.bool,
  hashtagName: _propTypes2.default.string,
  hashtagUrl: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
  preserveHash: _propTypes2.default.bool
};

Hashtag.defaultProps = {
  encodeHashtag: false,
  hashtagName: '',
  hashtagUrl: '{{hashtag}}',
  preserveHash: false
};