'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Link;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

function Link(_ref) {
  var children = _ref.children,
      href = _ref.href,
      onClick = _ref.onClick,
      newWindow = _ref.newWindow;

  return _react2.default.createElement(
    'a',
    {
      href: href,
      className: 'interweave__link',
      target: newWindow ? '_blank' : null,
      onClick: onClick || null,
      rel: 'noopener noreferrer'
    },
    children
  );
}

Link.propTypes = {
  children: _propTypes2.default.node.isRequired,
  href: _propTypes2.default.string.isRequired,
  newWindow: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
};

Link.defaultProps = {
  newWindow: false,
  onClick: null
};