'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = Url;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Url(_ref) {
  var children = _ref.children,
      props = (0, _objectWithoutProperties3.default)(_ref, ['children']);

  var url = children;

  if (!url.match(/^https?:\/\//)) {
    url = 'http://' + url;
  }

  return _react2.default.createElement(
    _Link2.default,
    (0, _extends3.default)({}, props, { href: url }),
    children
  );
} /**
   * @copyright   2016, Miles Johnson
   * @license     https://opensource.org/licenses/MIT
   * 
   */

Url.propTypes = {
  children: _propTypes2.default.string.isRequired,
  urlParts: _propTypes2.default.shape({
    scheme: _propTypes2.default.string,
    auth: _propTypes2.default.string,
    host: _propTypes2.default.string,
    port: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
    path: _propTypes2.default.string,
    query: _propTypes2.default.string,
    fragment: _propTypes2.default.string
  })
};

Url.defaultProps = {
  urlParts: {}
};