'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TOP_LEVEL_TLDS = exports.ATTRIBUTES_TO_PROPS = exports.ATTRIBUTES = exports.FILTER_CAST_BOOL = exports.FILTER_CAST_NUMBER = exports.FILTER_DENY = exports.FILTER_ALLOW = exports.TAGS_BLACKLIST = exports.TAGS = exports.CONFIG_BLOCK = exports.CONFIG_INLINE = exports.TYPE_INLINE_BLOCK = exports.TYPE_BLOCK = exports.TYPE_INLINE = exports.PARSER_DENY = exports.PARSER_ALLOW = exports.EMAIL_PATTERN = exports.EMAIL_USERNAME_PATTERN = exports.EMAIL_CLASS_PART = exports.IP_PATTERN = exports.IP_V4_PATTERN = exports.IP_V4_PART = exports.URL_PATTERN = exports.URL_FRAGMENT_PATTERN = exports.URL_QUERY_PATTERN = exports.URL_PATH_PATTERN = exports.URL_PORT_PATTERN = exports.URL_HOST_PATTERN = exports.URL_AUTH_PATTERN = exports.URL_SCHEME_PATTERN = exports.URL_CHAR_PART = exports.HASHTAG_PATTERN = exports.ALNUM_CHAR = undefined;

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ALNUM_CHAR = exports.ALNUM_CHAR = '[a-z0-9]{1}'; /**
                                                      * @copyright   2016, Miles Johnson
                                                      * @license     https://opensource.org/licenses/MIT
                                                      * 
                                                      */

var HASHTAG_PATTERN = exports.HASHTAG_PATTERN = '#([-a-z0-9_]+)';

var URL_CHAR_PART = exports.URL_CHAR_PART = 'a-z0-9-_~%!$&\'*+;:@';var URL_SCHEME_PATTERN = exports.URL_SCHEME_PATTERN = '(https?://)?';
var URL_AUTH_PATTERN = exports.URL_AUTH_PATTERN = '([' + URL_CHAR_PART + ']+@)?';
var URL_HOST_PATTERN = exports.URL_HOST_PATTERN = '((?:www\\.)?' + ALNUM_CHAR + '[-a-z0-9.]*[-a-z0-9]+\\.[a-z]{2,24}(?:\\.[a-z]{2,24})?)';
var URL_PORT_PATTERN = exports.URL_PORT_PATTERN = '(:[0-9]+)?';
var URL_PATH_PATTERN = exports.URL_PATH_PATTERN = '(/[' + URL_CHAR_PART + '/]*(?:\\.[a-z]{2,8})?)?';
var URL_QUERY_PATTERN = exports.URL_QUERY_PATTERN = '(\\?[' + URL_CHAR_PART + '=\\[\\]/\\\\]*)?';
var URL_FRAGMENT_PATTERN = exports.URL_FRAGMENT_PATTERN = '(#[\\w%/]*)?';
var URL_PATTERN = exports.URL_PATTERN = [URL_SCHEME_PATTERN, URL_AUTH_PATTERN, URL_HOST_PATTERN, URL_PORT_PATTERN, URL_PATH_PATTERN, URL_QUERY_PATTERN, URL_FRAGMENT_PATTERN].join('');

var IP_V4_PART = exports.IP_V4_PART = '(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)';
var IP_V4_PATTERN = exports.IP_V4_PATTERN = '(' + IP_V4_PART + '\\.' + IP_V4_PART + '\\.' + IP_V4_PART + '\\.' + IP_V4_PART + ')';
var IP_PATTERN = exports.IP_PATTERN = [URL_SCHEME_PATTERN, URL_AUTH_PATTERN, IP_V4_PATTERN, URL_PORT_PATTERN, URL_PATH_PATTERN, URL_QUERY_PATTERN, URL_FRAGMENT_PATTERN].join('');

var EMAIL_CLASS_PART = exports.EMAIL_CLASS_PART = '[a-z0-9!#$%&?*+=_{|}~-]+';
var EMAIL_USERNAME_PATTERN = exports.EMAIL_USERNAME_PATTERN = '(' + ALNUM_CHAR + EMAIL_CLASS_PART + '(?:\\.' + EMAIL_CLASS_PART + ')*' + ALNUM_CHAR + ')';
var EMAIL_PATTERN = exports.EMAIL_PATTERN = EMAIL_USERNAME_PATTERN + '@' + URL_HOST_PATTERN;

var PARSER_ALLOW = exports.PARSER_ALLOW = 1;var PARSER_DENY = exports.PARSER_DENY = 2;var TYPE_INLINE = exports.TYPE_INLINE = 'inline';
var TYPE_BLOCK = exports.TYPE_BLOCK = 'block';
var TYPE_INLINE_BLOCK = exports.TYPE_INLINE_BLOCK = 'inline-block';var CONFIG_INLINE = exports.CONFIG_INLINE = {
  rule: PARSER_ALLOW,
  type: TYPE_INLINE,
  inline: true,
  block: false,
  self: false,
  void: false,
  parent: [],
  children: []
};

var CONFIG_BLOCK = exports.CONFIG_BLOCK = {
  rule: PARSER_ALLOW,
  type: TYPE_BLOCK,
  inline: true,
  block: true,
  self: true,
  void: false,
  parent: [],
  children: []
};

var tagConfigs = {
  a: {
    type: TYPE_INLINE_BLOCK,
    block: true
  },
  address: {
    self: false
  },
  audio: {
    children: ['track', 'source']
  },
  br: {
    inline: false,
    void: true
  },
  button: {
    type: TYPE_INLINE_BLOCK
  },
  dd: {
    parent: ['dl']
  },
  dl: {
    children: ['dt']
  },
  dt: {
    parent: ['dl'],
    children: ['dd']
  },
  figcaption: {
    parent: ['figure']
  },
  footer: {
    self: false
  },
  header: {
    self: false
  },
  h1: {
    self: false
  },
  h2: {
    self: false
  },
  h3: {
    self: false
  },
  h4: {
    self: false
  },
  h5: {
    self: false
  },
  h6: {
    self: false
  },
  hr: {
    inline: false,
    block: false,
    void: true
  },
  img: {
    inline: false,
    void: true
  },
  li: {
    self: false,
    parent: ['ul', 'ol']
  },
  main: {
    self: false
  },
  ol: {
    children: ['li']
  },
  picture: {
    children: ['source', 'img']
  },
  source: {
    inline: false,
    parent: ['audio', 'video', 'picture'],
    void: true
  },
  span: {
    self: true
  },
  table: {
    children: ['thead', 'tbody', 'tfoot', 'tr']
  },
  tbody: {
    parent: ['table'],
    children: ['tr']
  },
  td: {
    parent: ['tr']
  },
  tfoot: {
    parent: ['table'],
    children: ['tr']
  },
  th: {
    parent: ['tr']
  },
  thead: {
    parent: ['table'],
    children: ['tr']
  },
  tr: {
    parent: ['table', 'tbody', 'thead', 'tfoot'],
    children: ['th', 'td']
  },
  track: {
    inline: false,
    parent: ['audio', 'video'],
    void: true
  },
  ul: {
    children: ['li']
  },
  video: {
    children: ['track', 'source']
  }
};

function createConfigBuilder(config) {
  return function (tagName) {
    tagConfigs[tagName] = (0, _extends3.default)({}, config, tagConfigs[tagName] || {});
  };
}

['a', 'abbr', 'b', 'br', 'button', 'cite', 'code', 'del', 'dfn', 'em', 'i', 'img', 'ins', 'kbd', 'label', 'mark', 'output', 'picture', 'q', 's', 'samp', 'source', 'span', 'strong', 'sub', 'sup', 'time', 'track', 'u', 'var', 'video'].forEach(createConfigBuilder(CONFIG_INLINE));

['address', 'article', 'aside', 'audio', 'blockquote', 'dd', 'details', 'div', 'dl', 'dt', 'fieldset', 'figcaption', 'figure', 'footer', 'header', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'hr', 'legend', 'li', 'main', 'nav', 'ol', 'p', 'pre', 'section', 'summary', 'table', 'thead', 'tbody', 'tfoot', 'tr', 'th', 'td', 'ul'].forEach(createConfigBuilder(CONFIG_BLOCK));

var TAGS = exports.TAGS = (0, _freeze2.default)(tagConfigs);

var TAGS_BLACKLIST = exports.TAGS_BLACKLIST = {
  applet: true,
  body: true,
  canvas: true,
  embed: true,
  frame: true,
  frameset: true,
  head: true,
  html: true,
  iframe: true,
  object: true,
  script: true,
  style: true
};

var FILTER_ALLOW = exports.FILTER_ALLOW = 1;
var FILTER_DENY = exports.FILTER_DENY = 2;
var FILTER_CAST_NUMBER = exports.FILTER_CAST_NUMBER = 3;
var FILTER_CAST_BOOL = exports.FILTER_CAST_BOOL = 4;

var ATTRIBUTES = exports.ATTRIBUTES = (0, _freeze2.default)({
  alt: FILTER_ALLOW,
  cite: FILTER_ALLOW,
  class: FILTER_ALLOW,
  colspan: FILTER_CAST_NUMBER,
  controls: FILTER_CAST_BOOL,
  datetime: FILTER_ALLOW,
  default: FILTER_CAST_BOOL,
  disabled: FILTER_CAST_BOOL,
  dir: FILTER_ALLOW,
  height: FILTER_ALLOW,
  href: FILTER_ALLOW,
  id: FILTER_ALLOW,
  kind: FILTER_ALLOW,
  label: FILTER_ALLOW,
  lang: FILTER_ALLOW,
  loop: FILTER_CAST_BOOL,
  muted: FILTER_CAST_BOOL,
  poster: FILTER_ALLOW,
  role: FILTER_ALLOW,
  rowspan: FILTER_CAST_NUMBER,
  span: FILTER_CAST_NUMBER,
  src: FILTER_ALLOW,
  target: FILTER_ALLOW,
  title: FILTER_ALLOW,
  width: FILTER_ALLOW
});

var ATTRIBUTES_TO_PROPS = exports.ATTRIBUTES_TO_PROPS = (0, _freeze2.default)({
  class: 'className',
  colspan: 'colSpan',
  datetime: 'dateTime',
  rowspan: 'rowSpan'
});

var TOP_LEVEL_TLDS = exports.TOP_LEVEL_TLDS = ['com', 'org', 'net', 'int', 'edu', 'gov', 'mil', 'aero', 'asia', 'cat', 'coop', 'jobs', 'mobi', 'museum', 'post', 'tel', 'travel', 'xxx', 'arpa', 'test', 'ac', 'ad', 'ae', 'af', 'ag', 'ai', 'al', 'am', 'an', 'ao', 'aq', 'ar', 'as', 'at', 'au', 'aw', 'ax', 'az', 'ba', 'bb', 'bd', 'be', 'bf', 'bg', 'bh', 'bi', 'bj', 'bl', 'bm', 'bn', 'bo', 'bq', 'br', 'bs', 'bt', 'bv', 'bw', 'by', 'bz', 'ca', 'cc', 'cd', 'cf', 'cg', 'ch', 'ci', 'ck', 'cl', 'cm', 'cn', 'co', 'cr', 'cu', 'cv', 'cw', 'cx', 'cy', 'cz', 'de', 'dj', 'dk', 'dm', 'do', 'dz', 'ec', 'ee', 'eg', 'eh', 'er', 'es', 'et', 'eu', 'fi', 'fj', 'fk', 'fm', 'fo', 'fr', 'ga', 'gb', 'gd', 'ge', 'gf', 'gg', 'gh', 'gi', 'gl', 'gm', 'gn', 'gp', 'gq', 'gr', 'gs', 'gt', 'gu', 'gw', 'gy', 'hk', 'hm', 'hn', 'hr', 'ht', 'hu', 'id', 'ie', 'il', 'im', 'in', 'io', 'iq', 'ir', 'is', 'it', 'je', 'jm', 'jo', 'jp', 'ke', 'kg', 'kh', 'ki', 'km', 'kn', 'kp', 'kr', 'kw', 'ky', 'kz', 'la', 'lb', 'lc', 'li', 'lk', 'lr', 'ls', 'lt', 'lu', 'lv', 'ly', 'ma', 'mc', 'md', 'me', 'mf', 'mg', 'mh', 'mk', 'ml', 'mm', 'mn', 'mo', 'mp', 'mq', 'mr', 'ms', 'mt', 'mu', 'mv', 'mw', 'mx', 'my', 'mz', 'na', 'nc', 'ne', 'nf', 'ng', 'ni', 'nl', 'no', 'np', 'nr', 'nu', 'nz', 'om', 'pa', 'pe', 'pf', 'pg', 'ph', 'pk', 'pl', 'pm', 'pn', 'pr', 'ps', 'pt', 'pw', 'py', 'qa', 're', 'ro', 'rs', 'ru', 'rw', 'sa', 'sb', 'sc', 'sd', 'se', 'sg', 'sh', 'si', 'sj', 'sk', 'sl', 'sm', 'sn', 'so', 'sr', 'st', 'su', 'sv', 'sx', 'sy', 'sz', 'tc', 'td', 'tf', 'tg', 'th', 'tj', 'tk', 'tl', 'tm', 'tn', 'to', 'tp', 'tr', 'tt', 'tv', 'tw', 'tz', 'ua', 'ug', 'uk', 'um', 'us', 'uy', 'uz', 'va', 'vc', 've', 'vg', 'vi', 'vn', 'vu', 'wf', 'ws', 'ye', 'yt', 'za', 'zm', 'zw'];