'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SHORTNAME_TO_UNICODE = exports.UNICODE_TO_SHORTNAME = exports.EMOJI_SHORTNAME_REGEX = exports.EMOJI_REGEX = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _emojiDatabase = require('emoji-database');

var _shortnameToUnicode = require('emoji-database/data/extra/shortname-to-unicode.json');

var _shortnameToUnicode2 = _interopRequireDefault(_shortnameToUnicode);

var _regex = require('emoji-database/regex');

var _regex2 = _interopRequireDefault(_regex);

var _shortname = require('emoji-database/regex/shortname');

var _shortname2 = _interopRequireDefault(_shortname);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var data = typeof _shortnameToUnicode2.default === 'string' ? JSON.parse(_shortnameToUnicode2.default) : _shortnameToUnicode2.default;
var emoji = {};

var UNICODE_TO_SHORTNAME = {};
var SHORTNAME_TO_UNICODE = {};

(0, _keys2.default)(data).forEach(function (name) {
  var shortname = ':' + name + ':';
  var unicode = data[name];
  var hexcode = (0, _emojiDatabase.fromUnicodeToHex)(unicode);
  var codepoint = (0, _emojiDatabase.fromHexToCodepoint)(hexcode);

  UNICODE_TO_SHORTNAME[unicode] = shortname;
  SHORTNAME_TO_UNICODE[shortname] = unicode;

  emoji[shortname] = {
    codepoint: codepoint,
    hexcode: hexcode,
    unicode: unicode
  };
});

exports.EMOJI_REGEX = _regex2.default;
exports.EMOJI_SHORTNAME_REGEX = _shortname2.default;
exports.UNICODE_TO_SHORTNAME = UNICODE_TO_SHORTNAME;
exports.SHORTNAME_TO_UNICODE = SHORTNAME_TO_UNICODE;
exports.default = emoji;