'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Matcher2 = require('../Matcher');

var _Matcher3 = _interopRequireDefault(_Matcher2);

var _Emoji = require('../components/Emoji');

var _Emoji2 = _interopRequireDefault(_Emoji);

var _emoji = require('../data/emoji');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var EmojiMatcher = function (_Matcher) {
  (0, _inherits3.default)(EmojiMatcher, _Matcher);

  function EmojiMatcher(name) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var factory = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    (0, _classCallCheck3.default)(this, EmojiMatcher);
    return (0, _possibleConstructorReturn3.default)(this, (EmojiMatcher.__proto__ || (0, _getPrototypeOf2.default)(EmojiMatcher)).call(this, name, (0, _extends3.default)({
      convertShortname: false,
      convertUnicode: false,
      renderUnicode: false
    }, options), factory));
  }

  (0, _createClass3.default)(EmojiMatcher, [{
    key: 'replaceWith',
    value: function replaceWith(match) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (this.options.renderUnicode) {
        return props.unicode;
      }

      return _react2.default.createElement(_Emoji2.default, props);
    }
  }, {
    key: 'asTag',
    value: function asTag() {
      return 'img';
    }
  }, {
    key: 'match',
    value: function match(string) {
      var response = null;

      if (this.options.convertShortname && string.indexOf(':') >= 0) {
        response = this.doMatch(string, _emoji.EMOJI_SHORTNAME_REGEX, function (matches) {
          return {
            shortname: matches[0].toLowerCase()
          };
        });

        if (response && response.shortname) {
          var unicode = _emoji.SHORTNAME_TO_UNICODE[response.shortname];

          if (unicode) {
            response.unicode = unicode;
          } else {
            response = null;
          }
        }
      }

      if (this.options.convertUnicode && !response) {
        response = this.doMatch(string, _emoji.EMOJI_REGEX, function (matches) {
          return {
            unicode: matches[0]
          };
        });

        if (response && response.unicode && !_emoji.UNICODE_TO_SHORTNAME[response.unicode]) {
          return null;
        }
      }

      return response;
    }
  }, {
    key: 'onAfterParse',
    value: function onAfterParse(content) {
      if (content.length === 1) {
        var _content = (0, _slicedToArray3.default)(content, 1),
            item = _content[0];

        if (typeof item !== 'string' && _react2.default.isValidElement(item) && item.type === _Emoji2.default) {
          item = item;

          return [_react2.default.cloneElement(item, (0, _extends3.default)({}, item.props, {
            enlargeEmoji: true
          }))];
        }
      }

      return content;
    }
  }]);
  return EmojiMatcher;
}(_Matcher3.default);

exports.default = EmojiMatcher;